version: '3'
services:
  discovery:
    image: phygitaleveris/pxpservicediscovery:v2
    ports:
      - 8761:8761
    tty:
      true
    restart:
      always

  generic-message:
    image: phygitaleveris/pxpgenericmessage:v7
    ports:
      - 8084:8084
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DRULES_ENGINE=http://rules-engine:8090/listener/
        -DDEVICE_AUTHENTICATION=http://device-authentication:8089/deviceauthentication/deviceId/
        -DMESSAGE_MANAGER=http://message-manager:8088/messageRequest/
    tty:
      true
    restart:
      always
    depends_on:
      - discovery
      - mongodb
      - rules-engine
      - message-manager
    links:
      - mongodb
      - discovery
      - rules-engine
      - message-manager

  message-manager:
    image: phygitaleveris/pxpmessagemanager:v4
    ports:
      - 8088:8088
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    links:
      - mongodb
      - discovery

  rules-engine:
    image: phygitaleveris/pxprulesengine:v15
    ports:
      - 8090:8090
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DMESSAGE_MANAGER=http://message-manager:8088/messageRequest/
        -DWEB_SOCKET:http://localhost:8005/message/
        -DMONGODB:mongodb://OvYWe4ksGEm7pTGl6nu4:peokgR1vOlc87tTepZn9C1Zbc0We53@35.194.68.222:27017/
    depends_on:
      - mongodb
      - discovery
      - message-manager
      - web-socket
    links:
      - mongodb
      - discovery
      - message-manager

  agency-manager:
    image: phygitaleveris/pxpagencymanager:v6
    ports:
      - 8081:8081
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    tty:
      true
    restart:
      always
    depends_on:
      - discovery
      - mongodb
    links:
      - mongodb
      - discovery

  client-manager:
    image: phygitaleveris/pxpclientmanager:v1
    ports:
      - 8085:8085
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    tty:
      true
    restart:
      always
    depends_on:
      - discovery
      - mongodb
    links:
      - mongodb
      - discovery

  journey-manager:
    image: phygitaleveris/pxpjourneymanager:v1
    ports:
      - 8092:8092
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DCLIENT_MANAGEMENT=http://client-manager:8085/clients/name/
    restart:
      always
    depends_on:
      - discovery    
      - mongodb
      - client-manager
    links:
      - mongodb
      - discovery
      - client-manager

  device-manager:
    image: phygitaleveris/pxpdevicemanager:v6
    ports:
      - 8082:8082
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    tty:
      true
    restart:
      always
    depends_on:
      - discovery
      - mongodb
    links:
      - mongodb
      - discovery

  user-manager:   
    image: phygitaleveris/pxpusermanager:v18
    ports:
      - 8083:8083
    environment:
      - MONGO_URI=mongodb
      - EUREKA_URI=discovery
      - DEVICES_URI=device-manager
      - PLACES_URI=agency-manager
      - JOURNEY_URI=journey-manager
      - HEALTHCHECK_URI=health-check
      - APPHEALTHCHECK_URI=app-health-check
      - ALERT_URI=alert-system
      - GENERIC_MSG_URI=generic-message
    depends_on:
      - discovery
      - mongodb
      - device-manager
      - agency-manager
      - journey-manager
      - alert-system
      - health-check
      - app-health-check
      - generic-message
    restart:
      always

  zuul-proxy:
    image: phygitaleveris/pxpzuulproxy:v3
    ports:
      - 8050:8050
    environment:
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    tty:
      true
    restart:
      always
    depends_on:
      - discovery

  send-token:   
    image: phygitaleveris/sendtoken:v1
    ports:
      - 8091:8091
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  health-check:   
    image: phygitaleveris/pxphealthcheck:v3
    ports:
      - 6060:6060
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DALERT_SYSTEM:http://localhost:3030/alert/
    depends_on:
      - mongodb
      - discovery
      - alert-system
    restart:
      always

  app-management:
    image: phygitaleveris/pxpappsmanagement:v3
    ports:
      - 8097:8097
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  app-feed:
    image: phygitaleveris/appfeed:v2
    ports:
      - 9010:9010
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  device-authentication:
    image: phygitaleveris/pxpdeviceauthentication:v2
    ports:
      - 8089:8089
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DDEVICE_MANAGER=http://device-manager:8082/devices/uuid/
    depends_on:
      - mongodb
      - discovery
      - device-manager
    restart:
      always

  face-recognition:
    image: phygitaleveris/appfacerecognition:v3
    ports:
      - 8086:8086
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  face-recognition-everis:
    image: phygitaleveris/appfacerecognitioneveris:v2
    ports:
      - 8093:8093
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  workflow-engine:
    image: phygitaleveris/pxpworkflowengine:v2
    ports:
      - 8010:8010
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  alert-system:
    image: phygitaleveris/pxpalertsystem:v1
    ports:
      - 3030:3030
    environment:
      - MONGO_URI=mongodb
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - mongodb
      - discovery
    restart:
      always

  app-health-check:
    image: phygitaleveris/pxpapphealthcheck:v2
    ports:
      - 7070:7070
    environment:
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
        -DALERT_SYSTEM:http://localhost:3030/alert/
        -DAPPS_MANAGER:http://localhost:8097/phapps/name/{name}/
    depends_on:
      - discovery
      - alert-system
      - app-management
    restart:
      always

  queue-manager:
    image: phygitaleveris/pxpqueuemanager:v1
    ports:
      - 8087:8087
    environment:
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - zookeeper-server
      - kafka-server1
      - discovery
    restart:
      always

  web-socket:
    image: phygitaleveris/pxpwebsocket:v1
    ports:
      - 8005:8005
    environment:
      - JAVA_OPTS=
        -DEUREKA_SERVER=http://discovery:8761/eureka
    depends_on:
      - discovery
    restart:
      always

  zookeeper-server:
    image: bitnami/zookeeper:latest
    ports:
      - 2181:2181
    environment:
      - ALLOW_ANONYMOUS_LOGIN=yes
    
  kafka-server1:
    image: bitnami/kafka:latest
    ports:
      - 9092:9092
    environment:
      - KAFKA_CFG_ZOOKEEPER_CONNECT=zookeeper-server:2181
      - KAFKA_CFG_ADVERTISED_LISTENERS=PLAINTEXT://localhost:9092
      - ALLOW_PLAINTEXT_LISTENER=yes
    depends_on:
      - zookeeper-server
    
  mongodb:
    container_name: mongodb
    image: mongo
    environment:
      # provide your credentials here
      - MONGO_INITDB_ROOT_USERNAME=OvYWe4ksGEm7pTGl6nu4
      - MONGO_INITDB_ROOT_PASSWORD=peokgR1vOlc87tTepZn9C1Zbc0We53
    ports:
      - 27017:27017
    volumes:
      - ./mongo-volume:/data/db